/*
 *  Brno University of Technology
 *
 *  Copyright (C) 2009-2010 by Brno University of Technology and the contributors
 *
 *  Complete list of developers available at our web site:
 *
 *       http://spl.utko.feec.vutbr.cz
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see http://www.gnu.org/licenses/.
 */
package cz.vutbr.feec.utko.opencv.operators.imageTransforms;

import java.util.List;

import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.parameter.ParameterType;
import com.rapidminer.parameter.ParameterTypeCategory;

import cz.vutbr.feec.utko.opencv.operators.imageProcessing.BaseProcessingOperator;

import static com.googlecode.javacv.cpp.opencv_core.*;
import static com.googlecode.javacv.cpp.opencv_imgproc.*;
import static com.googlecode.javacv.cpp.opencv_highgui.*;

public class LaplaceOperator extends BaseProcessingOperator{

	private static final String VALUE_OF_APERTURE = "Aperture size";
	private static final String[] VALUES_OF_APERTURE = new String[] { "1x1",
			"3x3", "5x5", "7x7" };
	public LaplaceOperator(OperatorDescription description) {
		super(description);
	}

	@Override
	public IplImage doWork(IplImage img) throws OperatorException {
		int depth = img.depth();
		int aperture = 0;
		if (depth == IPL_DEPTH_8S || depth == IPL_DEPTH_8U) {
			depth = IPL_DEPTH_16S;
		}

			aperture = getParameterAsInt(VALUE_OF_APERTURE);
			aperture = aperture * 2 + 1;
		IplImage temp = cvCreateImage(cvSize(img.width(), img.height()), depth, 3);
		IplImage outImage = cvCreateImage(cvSize(img.width(), img.height()),
				IPL_DEPTH_8U, 3);

		cvLaplace(img, temp, aperture);
		double scale = 255;
		double shift = 0;
		cvConvertScale(temp, outImage, scale, shift);
		return outImage;
	}
	
	@Override
	public List<ParameterType> getParameterTypes() {
		List<ParameterType> p = super.getParameterTypes();
		p.add(new ParameterTypeCategory(VALUE_OF_APERTURE, "Size of filter",
				VALUES_OF_APERTURE, 1));
		return p;
	}

}
